// $Id: ttcp_i.h,v 1.4 1999/06/18 03:31:16 schmidt Exp $

// ============================================================================
//
// = TAO tests
//    Throughput measurement using the TTCP benchmark adapted to work using TAO
//
// = FILENAME
//   ttcp_i.h
//
// = AUTHOR
//    Aniruddha Gokhale
//
// ============================================================================

#ifndef TTCP_I_H
#define TTCP_I_H

#include "ttcpS.h"

class ttcp_sequence_i: public POA_ttcp_sequence
{
public:
  ttcp_sequence_i();

  virtual void sendShortSeq (const ttcp_sequence::ShortSeq& ttcp_seq,
                             CORBA::Environment &IT_env)
      ACE_THROW_SPEC ((CORBA::SystemException));
  virtual void sendLongSeq (const ttcp_sequence::LongSeq& ttcp_seq,
                            CORBA::Environment &IT_env)
      ACE_THROW_SPEC ((CORBA::SystemException));
  virtual void sendDoubleSeq (const ttcp_sequence::DoubleSeq& ttcp_seq,
                              CORBA::Environment &IT_env)
      ACE_THROW_SPEC ((CORBA::SystemException));
  virtual void sendCharSeq (const ttcp_sequence::CharSeq& ttcp_seq,
                            CORBA::Environment &IT_env)
      ACE_THROW_SPEC ((CORBA::SystemException));
  virtual void sendStructSeq (const ttcp_sequence::StructSeq& ttcp_seq,
                              CORBA::Environment &IT_env)
      ACE_THROW_SPEC ((CORBA::SystemException));
  virtual void sendOctetSeq (const ttcp_sequence::OctetSeq& ttcp_seq,
                             CORBA::Environment &IT_env)
      ACE_THROW_SPEC ((CORBA::SystemException));

  // = Routines to calculate the time required to transfer.
  virtual void start_timer (CORBA::Environment &IT_env)
    ACE_THROW_SPEC ((CORBA::SystemException));
  virtual void stop_timer (CORBA::Environment &IT_env)
    ACE_THROW_SPEC ((CORBA::SystemException));

private:
  u_long nbytes_;
};

#endif /* TTCP_I_H */

